<script>
  // Import
  import { scaleLinear, scaleLog, scaleOrdinal } from 'd3-scale';
  import { schemeCategory10, schemeSet1, schemeSet2 } from 'd3-scale-chromatic';
  import { select } from 'd3-selection';
  import { axisBottom, axisLeft } from 'd3-axis';

  // Export data property
  export let data = null;

  // Dimensions
  const [height, width] = [400, 600];
  const margin = { top: 50, right: 5, bottom: 55, left: 50 };
  const innerWidth = width - margin.left - margin.right;
  const innerHeight = height - margin.top - margin.bottom;

  // Configure scales
  var yScale = scaleLinear().range([0,innerHeight]).domain([90,0]);
  var xScale = scaleLinear().range([0,innerWidth]).domain([0,5000]);
  var catScale = scaleOrdinal(schemeSet1).domain(['europe', 'asia', 'americas','africa']);
  var rScale = scaleLinear().range([5,20]).domain([0,321675014]);


  // Axis functions
  function xAxis(element) {
    select(element).call(axisBottom(xScale))
  }
  function yAxis(element) {
    select(element).call(axisLeft(yScale))
  }

</script>

<svg viewBox="0 0 {width} {height}" style="max-width: {width}px">
  <g transform="translate({margin.left}, {margin.top})">
    {#each data.countries as datapoint}
      {#if +datapoint.income > 0 & +datapoint.life_exp > 0}
        <circle cx={xScale(+datapoint.income)} 
                cy={yScale(+datapoint.life_exp)} 
                fill={catScale(datapoint.continent)} 
                r={rScale(datapoint.population)} />
      {/if}
    {/each}
    <g use:xAxis transform='translate(0, 295)'></g>
    <g use:yAxis transform='translate(0, 0)'></g>
  </g>
  <text 
    transform='translate(15,250),rotate(-90)'
    style="fill:currentcolor; 
          font-size:15px;">
    Life expectancy
</text>
<text 
  transform='translate(300,380)'
  style="fill:currentcolor; 
         font-size:15px;">
  Income
</text>
<text 
  transform='translate(230,30)'
  style="fill:currentcolor; 
         font-size:20px;
         font-weight: bold;">
  Gapminder scatterplot
</text>
<text 
  transform='translate(550,340)'
  style="fill:currentcolor; 
         font-size:20px;
         font-weight: bold;">
  1800
</text>
</svg>


